<?php
// $Id: profile.pages.inc,v 1.2 2007/12/08 14:06:22 goba Exp $

/**
 * @file
 * User page callbacks for the profile module.
 */

/**
 * Menu callback; display a list of user information.
 */
function profile_browse() {
  // Ensure that the path is converted to 3 levels always.
  list(, $name, $value) = array_pad(explode('/', $_GET['q'], 3), 3, '');
  $field = db_fetch_object(db_query("SELECT DISTINCT(fid), type, title, page, visibility FROM {profile_fields} WHERE name = '%s'", $name));
  
  if ($name && $field->fid) {
    // Only allow browsing of fields that have a page title set.
    if (empty($field->page)) {
      drupal_not_found();
      return;
    }
    // Do not allow browsing of private and hidden fields by non-admins.
    if (!user_access('administer users') && ($field->visibility == PROFILE_PRIVATE || $field->visibility == PROFILE_HIDDEN)) {
      drupal_access_denied();
      return;
    }

    // Compile a list of fields to show.
    $fields = array();
    $result = db_query('SELECT name, title, type, weight, page FROM {profile_fields} WHERE fid != %d AND visibility = %d ORDER BY weight', $field->fid, PROFILE_PUBLIC_LISTINGS);
    while ($record = db_fetch_object($result)) {
      $fields[] = $record;
    }

    // Determine what query to use:
    $arguments = array($field->fid);
    switch ($field->type) {
      case 'checkbox':
        $query = 'v.value = 1';
        break;
      case 'textfield':
      case 'selection':
        $query = "v.value = '%s'";
        $arguments[] = $value;
        break;
      case 'selection_hs':
        //      
        if (isset($value)) {
          $value = (integer)$value;
          //  ID   ID    
          $result = db_query('SELECT options FROM {profile_fields} WHERE name="%s"', $name);
          $tmp = (array)db_fetch_object($result);
          $bID_voc_profile = $tmp['options'];
          
          $result = db_query('SELECT vid FROM {term_data} WHERE tid=%d', $value);
          $tmp = (array)db_fetch_object($result);
          $bID_voc_tax = $tmp['vid'];
          //       ,  .
          if ($bID_voc_tax != $bID_voc_profile) { drupal_not_found(); return; }
          
          // Build breadcrumb based on first hierarchy of first term:
          $current->tid = $value;
          $breadcrumb = array();
          while ($parents = taxonomy_get_parents($current->tid)) {
            $current = array_shift($parents);
            $breadcrumb[] = l($current->name, 'profile/'.$name.'/'. $current->tid);
          }
          $breadcrumb[] = l(t('Users'), 'profile');
          $breadcrumb[] = l(t('Home'), NULL);
          $breadcrumb = array_reverse($breadcrumb);
          drupal_set_breadcrumb($breadcrumb);
          
          //    
          $temp = $temp2 = $array_tid = array();
          //       ,   
          $temp = db_fetch_object(db_query('SELECT * FROM {term_hierarchy} WHERE tid = %d', $value));
          for(; $temp->parent != 0;) {
            $temp2 = taxonomy_get_term($temp->parent);
            if (is_object($temp2)) {
              $array_tid[] = $temp2->tid;
            }
            $temp = db_fetch_object(db_query('SELECT * FROM {term_hierarchy} WHERE tid = %d', $temp2->tid));
          }
        }
        $name_field = taxonomy_get_term($value);
        $name_field = $name_field->name;
        
        $array_tid = array_reverse($array_tid);
        $array_tid[] = $value;
        $cnt_tid = count($array_tid);
        //$string_query = 'a:'.$cnt_tid.':{'; // : a:2:{i:0;s:4:"5370";i:1;s:4:"5381";}      a:1:{i:0;s:4:"5370";}
        $string_query = '';//'a:'.$cnt_tid.':{'; // : a:2:{i:0;s:4:"5370";i:1;s:4:"5381";}      a:1:{i:0;s:4:"5370";}
        for ($i=0; $i < $cnt_tid; $i++)
        {
          $len_st = strlen($array_tid[$i]);
          $string_query .= 'i:'.$i.';s:'.$len_st.':"'.$array_tid[$i].'";';
        }
        //$string_query .= '}';
        //echo '<pre>'. $string_query .'</pre>';
        $query = "v.value LIKE '%%%s%%'";
        $value = $string_query;
        $arguments[] = $value;
        
        break;
      case 'list':
        $query = "v.value LIKE '%%%s%%'";
        $arguments[] = $value;
        break;
      default:
        drupal_not_found();
        return;
    }

    // Extract the affected users:
    $result = pager_query("SELECT u.uid, u.access FROM {users} u INNER JOIN {profile_values} v ON u.uid = v.uid WHERE v.fid = %d AND $query AND u.access != 0 AND u.status != 0 ORDER BY u.access DESC", 20, 0, NULL, $arguments);

    $content = '';
    while ($account = db_fetch_object($result)) {
      $account = user_load(array('uid' => $account->uid));
      $profile = _profile_update_user_fields($fields, $account);
      $content .= theme('profile_listing', $account, $profile);
    }
    $output = theme('profile_wrapper', $content);
    $output .= theme('pager', NULL, 20);

    if ($field->type == 'selection' || $field->type == 'list' || $field->type == 'textfield') {
      $title = strtr(check_plain($field->page), array('%value' => theme('placeholder', $value)));
    }
    else if($field->type == 'selection_hs') {
      $title = strtr(check_plain($field->page), array('%value' => theme('placeholder', $name_field)));
    }
    else {
      $title = check_plain($field->page);
    }

    drupal_set_title($title);
    return $output;
  }
  else if ($name && !$field->fid) {
    drupal_not_found();
  }
  else {
    // Compile a list of fields to show.
    $fields = array();
    $result = db_query('SELECT name, title, type, weight, page FROM {profile_fields} WHERE visibility = %d ORDER BY category, weight', PROFILE_PUBLIC_LISTINGS);
    while ($record = db_fetch_object($result)) {
      $fields[] = $record;
    }

    // Extract the affected users:
    $result = pager_query('SELECT uid, access FROM {users} WHERE uid > 0 AND status != 0 AND access != 0 ORDER BY access DESC', 20, 0, NULL);

    $content = '';
    while ($account = db_fetch_object($result)) {
      $account = user_load(array('uid' => $account->uid));
      $profile = _profile_update_user_fields($fields, $account);
      $content .= theme('profile_listing', $account, $profile);
    }
    $output = theme('profile_wrapper', $content);
    $output .= theme('pager', NULL, 20);

    drupal_set_title(t('User list'));
    return $output;
  }
}

/**
 * Callback to allow autocomplete of profile text fields.
 */
function profile_autocomplete($field, $string) {
  $matches = array();
  if (db_result(db_query("SELECT COUNT(*) FROM {profile_fields} WHERE fid = %d AND autocomplete = 1", $field))) {
    $result = db_query_range("SELECT value FROM {profile_values} WHERE fid = %d AND LOWER(value) LIKE LOWER('%s%%') GROUP BY value ORDER BY value ASC", $field, $string, 0, 10);
    while ($data = db_fetch_object($result)) {
      $matches[$data->value] = check_plain($data->value);
    }
  }

  drupal_json($matches);
}
